package com.ibiz5.api.orderapi.resource;

import java.util.List;

import com.ibiz5.sample.domain.IBZ5ORDER;
import com.ibiz5.sample.service.IBZ5ORDERService;
import com.ibiz5.sample.service.dto.IBZ5ORDERSearchFilter;
import com.ibiz5.sample.domain.IBZ5ORDERDETAIL;
import com.ibiz5.sample.service.IBZ5ORDERDETAILService;
import com.ibiz5.sample.service.dto.IBZ5ORDERDETAILSearchFilter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import com.ibiz5.api.orderapi.dto.*;
import com.alibaba.fastjson.JSONObject;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

@Api(tags = {"IBZ5ORDER" })
@RestController
@RequestMapping("/rest/orderapi/ibz5order")
public class IBZ5ORDERResource {

    @Autowired
    private IBZ5ORDERService ibz5orderService;

    @Autowired
    private IBZ5ORDERDETAILService ibz5orderdetailService;

	@ApiOperation(value = "Create", tags = {"IBZ5ORDER" },  notes = "Create")
    @RequestMapping(method= RequestMethod.POST , value="")
	public IBZ5ORDERDTO createIBZ5ORDER(@RequestBody IBZ5ORDERDTO dto) {
		IBZ5ORDER po = dto.toPO();
		ibz5orderService.create(po);
		dto.fromPO(po);
		return dto;
	}

	@ApiOperation(value = "Update", tags = {"IBZ5ORDER" },  notes = "Update")
    @RequestMapping(method= RequestMethod.POST , value="/{ibz5orderid}")
	public IBZ5ORDERDTO updateIBZ5ORDER(@PathVariable String ibz5orderid,@RequestBody IBZ5ORDERDTO dto) {
		IBZ5ORDER po = dto.toPO();
		po.setIbz5orderid(ibz5orderid);
		ibz5orderService.update(po);
		dto.fromPO(po);
		return dto;
	}

	@ApiOperation(value = "Create", tags = {"IBZ5ORDER" },  notes = "Create")
    @RequestMapping(method= RequestMethod.POST , value="/{ibz5orderid}/ibz5orderdetail")
	public IBZ5ORDERDETAILDTO createIBZ5ORDERDETAIL(@PathVariable String ibz5orderid,@RequestBody IBZ5ORDERDETAILDTO dto) {
		IBZ5ORDERDETAIL po = dto.toPO();
		ibz5orderdetailService.create(po);
		dto.fromPO(po);
		return dto;
	}

	@ApiOperation(value = "Update", tags = {"IBZ5ORDER" },  notes = "Update")
    @RequestMapping(method= RequestMethod.POST , value="/{ibz5orderid}/ibz5orderdetail/{ibz5orderdetailid}")
	public IBZ5ORDERDETAILDTO updateIBZ5ORDERDETAIL(@PathVariable String ibz5orderid,@PathVariable String ibz5orderdetailid,@RequestBody IBZ5ORDERDETAILDTO dto) {
		IBZ5ORDERDETAIL po = dto.toPO();
		po.setIbz5orderdetailid(ibz5orderdetailid);
		ibz5orderdetailService.update(po);
		dto.fromPO(po);
		return dto;
	}

}
